#!/bin/bash

if [[ -f /etc/rc.d/init.d/functions ]]; then
    . /etc/rc.d/init.d/functions
fi
export USER="rserve2"

start() {
    if grep "kubepods\|docker" /proc/1/cgroup -qa; then
        # If R Server is installed, use path under R. Else, use path under Python Server.
        if [[ -f /opt/microsoft/mlserver/9.4.7/o16n/../libraries/RServer/RevoScaleR/rxLibs/x64/libstdc++.so.6 ]]; then
           export LD_PRELOAD=/opt/microsoft/mlserver/9.4.7/o16n/../libraries/RServer/RevoScaleR/rxLibs/x64/libstdc++.so.6
        else
           export LD_PRELOAD=/opt/microsoft/mlserver/9.4.7/o16n/../libraries/PythonServer/revoscalepy/rxLibs/libstdc++.so.6
        fi

        pushd /opt/microsoft/mlserver/9.4.7/o16n/Microsoft.MLServer.ComputeNode
        # If Ubuntu machine
        if [[ "$(. /etc/os-release; echo $NAME)" = "Ubuntu" ]]; then
           start-stop-daemon --start --quiet --user "rserve2" --chuid "rserve2" --chdir /opt/microsoft/mlserver/9.4.7/o16n/Microsoft.MLServer.ComputeNode --exec /bin/bash -- -c '/usr/bin/dotnet Microsoft.MLServer.ComputeNode.dll' > stdout.txt 2>stderr.txt &
        else
           daemon --user "rserve2" /usr/bin/dotnet Microsoft.MLServer.ComputeNode.dll  > stdout.txt 2>stderr.txt &
        fi
        popd
    else
        # If Ubuntu 14.04 machine, use "service" command.
        # Else for Ubuntu 16.04+ and RHEL, use systemctl commands
        if [[ -f /etc/issue && $(cat /etc/issue) == "Ubuntu 14.04"* ]]; then
           service computenode start
        else
           systemctl start computenode
        fi
    fi
}
stop() {
    if grep "kubepods\|docker" /proc/1/cgroup -qa; then
        pgrep -f "dotnet Microsoft.MLServer.ComputeNode.dll" | xargs kill -9
    else
        # If Ubuntu 14.04 machine, use "service" command.
        # Else for Ubuntu 16.04+ and RHEL, use systemctl commands
        if [[ -f /etc/issue && $(cat /etc/issue) == "Ubuntu 14.04"* ]]; then
           service computenode stop
        else
           systemctl stop computenode
        fi
    fi
}

case "$1" in
start)
        start
;;

stop)
        stop
        ;;

restart)
        echo "stopping Compute node"
        stop
        sleep 2
        echo "starting Compute node"
        start
;;
esac

exit 0
