#!/bin/bash

if [[ -f /etc/rc.d/init.d/functions ]]; then
    . /etc/rc.d/init.d/functions
fi
export USER="webnode_usr"

start() {
    if grep "kubepods\|docker" /proc/1/cgroup -qa; then
        pushd /opt/microsoft/mlserver/9.4.7/o16n/Microsoft.MLServer.WebNode

        # If Ubuntu machine
        if [[ "$(. /etc/os-release; echo $NAME)" = "Ubuntu" ]]; then
           start-stop-daemon --start --quiet --user "webnode_usr" --chuid "webnode_usr" --chdir /opt/microsoft/mlserver/9.4.7/o16n/Microsoft.MLServer.WebNode --exec /bin/bash -- -c '/usr/bin/dotnet Microsoft.MLServer.WebNode.dll' > stdout.txt 2>stderr.txt &
        else
           daemon --user "webnode_usr" /usr/bin/dotnet Microsoft.MLServer.WebNode.dll  > stdout.txt 2>stderr.txt &
        fi

        popd
    else
        # If Ubuntu 14.04 machine, use "service" command.
        # Else for Ubuntu 16.04+ and RHEL, use systemctl commands
        if [[ -f /etc/issue && $(cat /etc/issue) == "Ubuntu 14.04"* ]]; then
            service webnode start
        else
            systemctl start webnode
        fi
    fi
}
stop() {
    if grep "kubepods\|docker" /proc/1/cgroup -qa; then
        pgrep -f "dotnet Microsoft.MLServer.WebNode.dll" | xargs kill -9
    else
        # If Ubuntu 14.04 machine, use "service" command.
        # Else for Ubuntu 16.04+ and RHEL, use systemctl commands
        if [[ -f /etc/issue && $(cat /etc/issue) == "Ubuntu 14.04"* ]]; then
            service webnode stop
        else
            systemctl stop webnode
        fi
    fi
}

case "$1" in
start)
        start
;;

stop)
        stop
        ;;

restart)
        echo "stopping Web node"
        stop
        sleep 2
        echo "starting Web node"
        start
;;
esac

exit 0
